unit UCopiaDeSeguridad;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, Buttons, Grids, Outline;
  // DirOutln;

type
  TFrCopiaDeSeguridad = class(TForm)
    DirectoryListBox1: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    BHacerCopia: TBitBtn;
    BCancelar: TBitBtn;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure BCancelarClick(Sender: TObject);
    procedure BHacerCopiaClick(Sender: TObject);
    procedure CopyDirectory(Origen, Desti : string);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrCopiaDeSeguridad: TFrCopiaDeSeguridad;

implementation

{$R *.DFM}

procedure TFrCopiaDeSeguridad.FormKeyPress(Sender: TObject; var Key: Char);
begin
  IF key = #13 then
    FrCopiaDeSeguridad.FocusControl(FrCopiaDeSeguridad.FindNextControl(FrCopiaDeSeguridad.ActiveControl,True,True,False));
end;

procedure TFrCopiaDeSeguridad.BCancelarClick(Sender: TObject);
begin
  FrCopiaDeSeguridad.Close;
end;

procedure TFrCopiaDeSeguridad.BHacerCopiaClick(Sender: TObject);
var
  S: String;
begin
S := DirectoryListBox1.Directory + '\CopiaSeg' + FormatDateTime('dd"_"mm"_"yy',now);
MkDir(S);
DirectoryListBox1.Directory := S;
DirectoryListBox1.Update;
CopyDirectory(ExtractFilePath(Application.ExeName) + 'Tablas',s);
Application.MessageBox('La copia de seguridad ha finalizado con xito.','Informacin...',MB_OK + MB_ICONINFORMATION);
end;

procedure TFrCopiaDeSeguridad.CopyDirectory(Origen, Desti : string);
var
   Files : integer;
   FOrigen, FDesti : string;
   ok     : boolean;
   Search : TSearchRec;
begin
    Files := FindFirst(Origen + '\*.*', faAnyFile, Search);
    while Files = 0 do
     begin
          if Search.Attr <> faDirectory then
           begin
                FOrigen := Origen + '\' + Search.Name;
                FDesti := Desti + '\' + Search.Name;
                ok := CopyFile(PChar(FOrigen),PChar(FDesti),false);
                if not ok then ShowMessage('No se pudo copiar el fichero: '+
                                                              Search.Name);
           end
          else
           begin
                if (Search.Name <> '.') and (Search.Name <> '..') then
                 begin
                      ok := CreateDir(Desti + '\' + Search.Name);
                      if not ok then ShowMessage('No se pudo crear el directorio: '+
                                                                        Search.Name)
                      else CopyDirectory(Origen+'\'+Search.Name,Desti+'\'+Search.Name);
                 end;
           end;
          Files := FindNext(Search);
     end;
    FindClose(Search);
end;

end.
